<!doctype html>

<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>A Basic Todo App</title>
    <meta name="description" content="A basic website for managing todos.">
    <meta name="author" content="Hadi Chaudhri">

    <style>
        .todo-item.finished {
            text-color: #999;
            font-weight: normal;
            text-decoration: line-through;
        }

        .todo-item {
            cursor: pointer;
            font-weight: bold;
        }

        body {
            max-width: 650px;
            margin: 40px auto;
            padding: 0 10px;
            font: 18px/1.5 -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, "Noto Sans", sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol", "Noto Color Emoji";
            color: #444;
        }

        h1,
        h2,
        h3 {
            line-height: 1.2;
        }

        .hidden {
            display: none;
        }

        @media (prefers-color-scheme: dark) {
            body {
                color: #c9d1d9;
                background: #0d1117;
            }

            a:link {
                color: #58a6ff;
            }

            a:visited {
                color: #8e96f0;
            }
        }
    </style>

</head>

<body>
    <h1>Todos</h1>
    <h4 id="todo-instructions" class="hidden">Click on a todo item to complete it, and hold shift while clicking on a
        todo item to delete it.</h4>
    <ul id="todo-list"> </ul>

    <div>
        <h4>Add a todo item using the form below.</h4>
        <form id="form1" data-url="todos" method="post">
            <label for="name">Todo:</label>
            <input type="text" id="name" name="name">
            <button id="submit" type="submit" form="form1">Submit</button>
        </form>
    </div>

</body>
<script>
    const base_url = window.location.href;
    const todoList = document.getElementById("todo-list");

    const getFormJSON = (form) => {
        const data = new FormData(form);
        return Array.from(data.keys()).reduce((result, key) => {
            if (result[key]) {
                result[key] = data.getAll(key)
                return result
            }
            result[key] = data.get(key);
            return result;
        }, {});
    };

    async function handleSubmit(event, url) {
        event.preventDefault();
        const data = getFormJSON(event.target)
        console.log(data);
        if (data.name === "") {
            return;
        }
        const res = await post(url, data);
        const todo = await res.json();
        createTodoElement(todo);
        event.target.reset();
        updateInstructionDisplayMode();
    }

    function createTodoElement(todo) {
        const todoList = document.getElementById("todo-list");
        const todoElem = document.createElement("li");
        todoElem.appendChild(document.createTextNode(todo.name));
        todoElem.classList.add("todo-item");
        todoElem.setAttribute("data-todo-id", todo.id);
        if (todo.finished) {
            todoElem.classList.add("finished");
        }
        todoElem.addEventListener("click", handleTodoEvent);
        todoList.appendChild(todoElem);
    }

    function post(url, body) {
        return fetch(url, {
            method: "POST",
            headers: {
                "Content-Type": "application/json",
            },
            body: JSON.stringify(body)
        });
    }

    function patch(url, body) {
        return fetch(url, {
            method: "PATCH",
            headers: {
                "Content-Type": "application/json",
            },
            body: JSON.stringify(body)
        });
    }

    function get(url) {
        return fetch(url);
    }

    function del(url) {
        return fetch(url, {
            method: "DELETE",
        });
    }

    async function handleTodoEvent(event) {
        if (event.shiftKey) {
            deleteTodo(event);
        } else {
            toggleFinished(event);
        }
    }

    async function deleteTodo(event) {
        const el = event.target;
        const todo_id = el.dataset.todoId;
        await del("todos/" + todo_id);
        el.remove();
    }

    async function toggleFinished(event) {
        const el = event.target;
        const cls = "finished";
        const todo_id = el.dataset.todoId;
        const is_finished = el.classList.contains(cls);
        if (is_finished) {
            el.classList.remove(cls);
        } else {
            el.classList.add(cls);
        }
        await patch("todos/" + todo_id, { "id": todo_id, "finished": !is_finished });
    }

    async function addTodoItems() {
        const res = await get("todos");
        const todos = await res.json();
        for (todo of todos) {
            createTodoElement(todo);
        }
        updateInstructionDisplayMode();
    }

    function updateInstructionDisplayMode() {
        if (todoList.children.length > 0) {
            document.getElementById("todo-instructions").classList.remove("hidden");
        }
    }

    const form_id = "#form1"
    const form = document.querySelector(form_id);
    const target_url = form.dataset.url
    form.addEventListener('submit', (e) => handleSubmit(e, target_url));

    addTodoItems();

</script>

</html>
